<?php

namespace App\Services;

use App\Entities\Customer\ServiceEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\PaymentEntity;
use App\Helpers\PaymentHelper;
use App\Models\PaymentModel;
use App\Services\CommonService;
use App\Services\Customer\ClientService;
use App\Services\Customer\ServiceService;
use App\Services\Equipment\ServerPartService;
use App\Services\UserService;

class PaymentService extends CommonService
{
    private ?UserService $_userService = null;
    private ?ClientService $_clientService = null;
    private ?ServiceService $_serviceService = null;
    private ?ServerPartService $_serverPartService = null;
    public function __construct()
    {
        parent::__construct(new PaymentModel(), new PaymentHelper());
        $this->addClassName('Payment');
    }
    final public function getFormFields(): array
    {
        return [
            "serviceinfo_uid",
            "title",
            "amount",
            "billing",
            "billing_at",
            "content"
        ];
    }
    final public function getFormFilters(): array
    {
        return  [
            'clientinfo_uid',
            "serviceinfo_uid",
            'billing',
            'pay',
            'status',
            'user_uid',
        ];
    }
    final public function getIndexFields(): array
    {
        return [
            'clientinfo_uid',
            "serviceinfo_uid",
            'billing',
            'title',
            'amount',
            'billing_at',
            'pay',
            'status',
            'updated_at',
            'countdown',
            'user_uid',
        ];
    }
    final public function getBatchjobFields(): array
    {
        return ['pay', 'status'];
    }
    final public function getBatchjobButtons(): array
    {
        return [
            'batchjob' => '일괄 결제 ',
            'invoice' => '청구서 발행',
        ];
    }
    final public function getClientService(): ClientService
    {
        if (!$this->_clientService) {
            $this->_clientService = new ClientService();
        }
        return $this->_clientService;
    }
    final public function getUSerService(): UserService
    {
        if (!$this->_userService) {
            $this->_userService = new UserService();
        }
        return $this->_userService;
    }
    final public function getServiceService(): ServiceService
    {
        if ($this->_serviceService === null) {
            $this->_serviceService = new ServiceService();
        }
        return $this->_serviceService;
    }
    final public function getServerPartService(): ServerPartService
    {
        if (!$this->_serverPartService) {
            $this->_serverPartService = new ServerPartService();
        }
        return $this->_serverPartService;
    }

    //총 미납건수, 금액
    final public function getUnPaids(string $group, array $where = []): array
    {
        $rows = $this->getModel()->groupBy($group)
            ->select("{$group},COUNT(uid) as cnt, SUM(amount) as amount")
            ->where(['status' => STATUS['UNPAID']])
            ->where($where)
            ->get()->getResult();
        $unPaids = [];
        foreach ($rows as $row) {
            $unPaids[$row->$group] = ['cnt' => $row->cnt, 'amount' => $row->amount];
        }
        return $unPaids;
    }
    //서비스정보 설정
    final public function setService(string $action, ServiceEntity $serviceEntity, array $serviceFormDatas): PaymentEntity
    {
        switch ($action) {
            case 'create':
                $formDatas = [];
                $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid'] = $serviceEntity->getPK();
                $formDatas['serverinfo_uid'] = $serviceEntity->getServerInfoUID();
                $formDatas['title'] = $serviceEntity->getTitle();
                $formDatas['amount'] = $serviceEntity->getAmount();
                $formDatas['billing'] = PAYMENT['BILLING']['MONTH'];
                $formDatas['billing_at'] = $serviceEntity->getBillingAt();
                $entity = parent::create($formDatas);
                break;
            case 'modify':
                $entity = $serviceEntity->getPaymentEntity();
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 오류발생:결제정보를 찾을수 없습니다.");
                }
                $formDatas = [];
                $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid'] = $serviceEntity->getPK();
                $formDatas['serverinfo_uid'] = $serviceEntity->getServerInfoUID();
                $formDatas['title'] = $serviceEntity->getTitle();
                $formDatas['amount'] = $serviceEntity->getAmount();
                $formDatas['billing'] = PAYMENT['BILLING']['MONTH'];
                $formDatas['billing_at'] = $serviceEntity->getBillingAt();
                $entity = parent::modify($entity, $formDatas);
                break;
            default:
                throw new \Exception(__METHOD__ . "에서 오류발생:{$action}은 정의되지 않은 작업입니다.");
                // break;
        }
        return $entity;
    }
    final public function setServerPart(string $action, ServerPartEntity $serverPartEntity, array $servicePartFormDatas): PaymentEntity
    {
        switch ($action) {
            case 'create':
                $formDatas                    = [];
                $formDatas['clientinfo_uid']     = $serverPartEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid']    = $serverPartEntity->getServiceInfoUID();
                $formDatas['serverinfo_uid']     = $serverPartEntity->getServerInfoUID(); //서버연결정보 수정시에 필요함
                //타이틀은 기타의 경우 직접작성한 제목을 등록하고 아닌경우는 Part의 Title을 사용한다.
                $formDatas['title']              = $serverPartEntity->getPartEntity()->getTitle();
                $formDatas['amount']             = $serverPartEntity->getTotalAmount(); //단가*cnt
                $formDatas['billing']            = $serverPartEntity->getBilling();
                //당일결체일로 설정
                $formDatas['billing_at'] = date("Y-m-d");
                $entity = parent::create($formDatas);
                break;
            case 'modify':
                $entity = $serverPartEntity->getPaymentEntity();
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 오류발생:결제정보를 찾을수 없습니다.");
                }
                $formDatas                    = [];
                $formDatas['clientinfo_uid']     = $serverPartEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid']    = $serverPartEntity->getServiceInfoUID();
                $formDatas['serverinfo_uid']     = $serverPartEntity->getServerInfoUID(); //서버연결정보 수정시에 필요함
                //타이틀은 기타의 경우 직접작성한 제목을 등록하고 아닌경우는 Part의 Title을 사용한다.
                $formDatas['title']              = $serverPartEntity->getPartEntity()->getTitle();
                $formDatas['amount']             = $serverPartEntity->getTotalAmount(); //단가*cnt
                $formDatas['billing']            = $serverPartEntity->getBilling();
                $entity = parent::modify($entity, $formDatas);
                break;
            default:
                throw new \Exception(__METHOD__ . "에서 오류발생:{$action}은 정의되지 않은 작업입니다.");
                // break;
        }
        return $entity;
    }
    //기본 기능부분
    //FieldForm관련용
    final public function getFormOption(string $field, array $options = []): array
    {
        switch ($field) {
            case 'serviceinfo_uid':
                $options = $this->getServiceService()->getEntities();
                break;
            default:
                $options = parent::getFormOption($field, $options);
                break;
        }
        return $options;
    }
    //Action 기능
    public function create(array $formDatas): PaymentEntity
    {
        if (!array_key_exists('serviceinfo_uid', $formDatas)) {
            throw new \Exception("서비스정보가 없습니다.");
        }
        //서비스정보 가져오기
        $serviceEntity = $this->getServiceService()->getEntity($formDatas['serviceinfo_uid']);
        if (!$serviceEntity instanceof ServiceEntity) {
            throw new \Exception(__METHOD__ . "에서 오류발생: 서비스정보[{$formDatas['serviceinfo_uid']}]를 찾을수 없습니다.");
        }
        $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUID();
        return parent::create($formDatas);
    }
    //List 검색용
    //OrderBy 처리
    final public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->getModel()->orderBy('billing_at ASC');
        parent::setOrderBy($field, $value);
    }
}
